
import yoda
from math import sqrt

hname = 'outputFileName'

hists = yoda.read('%s.yoda' % hname)
tags = sorted(hists.keys())

f = open('%s_mod.yoda' % hname, 'w')
for h in tags:
  ident = int(h[-10:-8])
  tag = h[:-10] + '0%i' + h[-8:]
  modify = 'sum' if ident >= 10 else 'diff' if ident >= 07 else ''
  if modify:
    if 'diff' in modify:
      ctl = tag % (ident - 3)
      fwd = tag % (ident - 6)
      for i in range(hists[h].numPoints):
        ydiff  = hists[ctl].bins[i].mean if hists[ctl].bins[i].mean else 0.0
        ydiff -= hists[fwd].bins[i].mean if hists[fwd].bins[i].mean else 0.0
        bsum = hists[ctl].bins[i] + hists[fwd].bins[i]
        yerr = bsum.stdErr if bsum.numEntries else 0.0
        hists[h].points[i].y = ydiff
        hists[h].points[i].yErrs = (yerr, yerr)
    elif 'sum' in modify:
      ctl = tag % (ident - 6)
      fwd = tag % (ident - 9)
      for i in range(hists[h].numPoints):
        bsum = hists[ctl].bins[i] + hists[fwd].bins[i]
        ysum = bsum.mean if bsum.numEntries else 0.0
        yerr = bsum.stdErr if bsum.numEntries else 0.0
        hists[h].points[i].y = ysum
        hists[h].points[i].yErrs = (yerr, yerr)
  yoda.writeYODA(hists[h], f)
f.close()

